local hudmodname = "jiskpizzatime"
/*
local hud_debug = CV_RegisterVar({
	name = "hud_debug",
	defaultvalue = "100",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
})

local hud_debug2 = CV_RegisterVar({
	name = "hud_debug2",
	defaultvalue = "0",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
})
*/
-- LAPS AND PIZZATIME-MOVEUP HUD --
local timeafteranimation = 0

local bar_hud = function(v,player)
	if JISK_PIZZATIME then
		local expectedtime = TICRATE*3
		local start = 300*FRACUNIT
		local finish = 175*FRACUNIT
		local ese = ease.inoutcubic(( (FU) / (expectedtime) )*JISK_PIZZATIMETICS, start, finish)
		
		local bar = v.cachePatch("SHOWTIMEBAR")
		local bar2 = v.cachePatch("SHOWTIMEBAR2")
		
		--1/JISK_TIMELEFT
		--JISK_TIMELEFT
		
		--ease.linear(fixed_t t, [[fixed_t start], fixed_t end])
		if JISK_TIMELIMIT.value then
			local bar_start = 0
			local bar_finish = 170*FRACUNIT
			local themath = FixedMul(FixedDiv((FU), (JISK_TIMELIMIT.value*TICRATE*60)*FRACUNIT),JISK_TIMELEFT*FRACUNIT)
			local barese = min(ease.linear(themath, bar_start,bar_finish), bar_finish) -- shortcut with tweens lol
			
			-- Fix negative errors?
			if barese < 0 then
				barese = 0
			end
			
			if JISK_PIZZATIMETICS < expectedtime then -- during animation
				--purple bar, +1 fracunit because i want it inside the box 
				-- MAX VALUE FOR HSCALE: FRACUNIT*150
				v.drawStretched(91*FRACUNIT, ese + (5*FU)/2, barese, (FU/2) - (FU/12), bar2, V_SNAPTOBOTTOM)
				--brown overlay
				v.drawScaled(90*FRACUNIT, ese, FU/2, bar, V_SNAPTOBOTTOM)
				
			else -- after animation
				v.drawStretched(91*FRACUNIT, finish + (5*FU)/2, barese, (FU/2) - (FU/12), bar2, V_SNAPTOBOTTOM)
				v.drawScaled(90*FRACUNIT, finish, FU/2, bar, V_SNAPTOBOTTOM)
				--v.drawString(int x, int y, string text, [int flags, [string align]])
				if timeafteranimation then
					local timestring = G_TicsToMTIME(JISK_TIMELEFT,true)
					local x = 170
					local y = 180
					--drawSuperText(v, 160, 183+120-PTHUD.PizzaTimeTimerY,str,{font = 'PTFNT', flags = V_SNAPTOBOTTOM, align = 'center'})
					if timeafteranimation < 10 then
						--v.drawString(165, y + 5, timestring, V_SNAPTOBOTTOM|(10-timeafteranimation)<<V_ALPHASHIFT , "center")
						drawSuperText(v, x, y, timestring,{font = 'PTFNT', flags = (V_SNAPTOBOTTOM|(10-timeafteranimation)<<V_ALPHASHIFT), align = 'center'})
					else
						if JISK_TIMELEFT then
							/* unused flickering code
							if JISK_TIMELEFT < 10*TICRATE then
								if (JISK_TIMELEFT % TICRATE) == 0 then
									--v.drawString(165, y + 5, "\x85"..timestring, V_SNAPTOBOTTOM , "center")
									drawSuperText(v, x, y, "\x85"..timestring,{font = 'PTFNT', flags = V_SNAPTOBOTTOM, align = 'center'})
									return
								end
								drawSuperText(v, x, y, timestring,{font = 'PTFNT', flags = V_SNAPTOBOTTOM, align = 'center'})
								--v.drawString(165, y + 5, timestring, V_SNAPTOBOTTOM , "center")
							end
							*/
							--v.drawString(165, y + 5, timestring, V_SNAPTOBOTTOM , "center")
							drawSuperText(v, x, y, timestring,{font = 'PTFNT', flags = V_SNAPTOBOTTOM, align = 'center'})
						else
							drawSuperText(v, x, y, "TIME OVER!",{font = 'PTFNT', flags = V_SNAPTOBOTTOM, align = 'center'})
						end
					end
				end
				timeafteranimation = $ + 1
			end
		end
	else
		timeafteranimation = 0
	end
end

local itspizzatime_hud = function(v,player)
	if JISK_PIZZATIME and JISK_PIZZATIMETICS and JISK_PIZZATIMETICS < 10*TICRATE then
		local patch = v.cachePatch("ITSPIZZATIME1")
		if JISK_HOMEWORK.value then
			patch = v.cachePatch("IWANTSUMMATHAT")
		end
		if leveltime % 3 then
			patch = v.cachePatch("ITSPIZZATIME2")
			if JISK_HOMEWORK.value then
				patch = v.cachePatch("IWANTSUMMATHAT2")
			end
		end
		if JISK_HOMEWORK.value then
			v.drawScaled(0, (250*FU) - (JISK_PIZZATIMETICS*FU)*3, FU/2, patch)
		else
			v.drawScaled(100*FRACUNIT, (250*FU) - (JISK_PIZZATIMETICS*FU)*3, FU/2, patch)
		end
	end
end

local tooltips_hud = function(v,player)
	local exitingCount, playerCount = JISK_COUNT()
	local practicemodetext = "\x84\* PRACTICE MODE *"
	local dynamiclapstext = "\x82\* DYNAMIC LAPS: "..JISK_LAPS.." / "..JISK_DYNAMICMAXLAPS.." *"
	local lapsandmaxlapstext = "\x82\* LAPS: "..JISK_LAPS.." / "..JISK_MAXLAPS.value.." *"
	local lapstext = "\x82\* LAPS: "..JISK_LAPS.." *"
	local lapsperplayertext = "\x82\* YOUR LAPS: "..player.lapsdid.." / "..JISK_MAXLAPS_PERPLAYER.value.." *"

	if JISK_PIZZATIME then

		
		if player.stuntime then
			v.drawString(160, 100, "You will be unfrozen in: "..player.stuntime/TICRATE.. " seconds.", V_TRANSLUCENT|V_SNAPTOBOTTOM|V_PERPLAYER, "center")
		end
		
		if (not player.pizzaface) and (player.exiting) and (not JISK_QUITTING) and (not player.playerstate == PST_DEAD) and (exitingCount ~= playerCount) then
			v.drawString(160, 120, "\x85\* Press FIRE to try a new lap! *", V_TRANSLUCENT|V_SNAPTOBOTTOM|V_PERPLAYER, "center")
		end
		if timeafteranimation then
			if timeafteranimation < 10 then
				if (playerCount == 1) then
					v.drawString(165, 157, practicemodetext, V_SNAPTOBOTTOM|(10-timeafteranimation)<<V_ALPHASHIFT, "center")
				end
				if player.pizzaface then
					if player.pizzachargecooldown then
						v.drawString(165, 157, "\x85\* COOLING DOWN *", V_SNAPTOBOTTOM|(10-timeafteranimation)<<V_ALPHASHIFT, "center")
					elseif player.pizzacharge then
						local percentage = FixedMul(FixedDiv(1*FRACUNIT, 35*FRACUNIT),35*FRACUNIT)>>FRACBITS
						
						v.drawString(165, 157, "\x85\* CHARGING \$percentage\% *", V_SNAPTOBOTTOM|(10-timeafteranimation)<<V_ALPHASHIFT, "center")
					else
						v.drawString(165, 157, "\x85\* HOLD FIRE TO TELEPORT *", V_SNAPTOBOTTOM|(10-timeafteranimation)<<V_ALPHASHIFT, "center")
					end
				end
				-- Early returns start here --
				if player.pizzaface and JISK_LAPPINGTYPE.value == 2 then return end
				if JISK_LAPPINGTYPE.value == 2 then
					v.drawString(165, 165, lapsperplayertext , V_SNAPTOBOTTOM|(10-timeafteranimation)<<V_ALPHASHIFT, "center")
					return
				end
				if JISK_DYNAMICLAPS.value then
					v.drawString(165, 165, dynamiclapstext , V_SNAPTOBOTTOM|(10-timeafteranimation)<<V_ALPHASHIFT, "center")
					return
				end
				
				if JISK_MAXLAPS.value then
					v.drawString(165, 165, lapsandmaxlapstext, V_SNAPTOBOTTOM|(10-timeafteranimation)<<V_ALPHASHIFT, "center")
					return
				else
					v.drawString(165, 165, lapstext, V_SNAPTOBOTTOM|(10-timeafteranimation)<<V_ALPHASHIFT, "center")
					return
				end
			else
				if (playerCount == 1) then
					v.drawString(165, 157,practicemodetext , V_SNAPTOBOTTOM, "center")
				end
				if player.pizzaface then
					if player.pizzachargecooldown then
						v.drawString(165, 157, "\x85\* COOLING DOWN *", V_SNAPTOBOTTOM, "center")
					elseif player.pizzacharge then
						local percentage = (FixedDiv(player.pizzacharge*FRACUNIT, 35*FRACUNIT)*100)>>FRACBITS
						
						v.drawString(165, 157, "\x85\* CHARGING \$percentage\% *", V_SNAPTOBOTTOM, "center")
					else
						v.drawString(165, 157, "\x85\* HOLD FIRE TO TELEPORT *", V_SNAPTOBOTTOM, "center")
					end
				end
				-- Early returns start here --
				if player.pizzaface and JISK_LAPPINGTYPE.value == 2 then return end
				if JISK_LAPPINGTYPE.value == 2 then
					v.drawString(165, 165, lapsperplayertext , V_SNAPTOBOTTOM, "center")
					return
				end
				
				if JISK_DYNAMICLAPS.value then
					v.drawString(165, 165, dynamiclapstext, V_SNAPTOBOTTOM, "center")
					return
				end
				
				if JISK_MAXLAPS.value then
					v.drawString(165, 165, lapsandmaxlapstext, V_PERPLAYER|V_SNAPTOBOTTOM, "center")
					return
				else
					v.drawString(165, 165, lapstext, V_PERPLAYER|V_SNAPTOBOTTOM, "center")
					return
				end
			end
		end
	end
end

--announcements
local announcements_hud = function(v,player)
	for i,an in ipairs(JISK_ANNOUNCEMENTS) do
		local inversecalc = 10-(an.fuse_start - an.fuse)
		local inversecalc_end = 10-an.fuse
		local spacing = 8
		local offset = (i*spacing)-spacing
		if (an.fuse_start - an.fuse) < 10 then
			if i == 1 then
				v.drawString(160, offset, an.text, V_SNAPTOTOP|inversecalc<<V_ALPHASHIFT, "center")
			else
				v.drawString(160, offset, an.text, V_SNAPTOTOP|inversecalc<<V_ALPHASHIFT, "center")
			end
		elseif an.fuse < 10 then
			if i == 1 then
				v.drawString(160, offset, an.text, V_SNAPTOTOP|inversecalc_end<<V_ALPHASHIFT, "center")
			else
				v.drawString(160, offset, an.text, V_SNAPTOTOP|inversecalc_end<<V_ALPHASHIFT, "center")
			end
		else
			if i == 1 then
				v.drawString(160, offset, an.text, V_SNAPTOTOP, "center")
			else
				v.drawString(160, offset, an.text, V_SNAPTOTOP, "center")
			end
		end
	end
end

customhud.SetupItem("ptje_bar", hudmodname, bar_hud, "game", 0)
customhud.SetupItem("ptje_itspizzatime", hudmodname, itspizzatime_hud, "game", 0)
customhud.SetupItem("ptje_tooltips", hudmodname, tooltips_hud, "game", 0)
customhud.SetupItem("ptje_announcements", hudmodname, announcements_hud, "game", 0)
